rem
rem Batch file to process all of the Polyray data files.
rem 
rem Processing all of the data files can take one or more days, depending
rem on the speed of your processor.  If you want a quick look, then
rem move to a subdirectory and look for an appropriate test image to render.
rem
rem You need to have POLYRAY_PATH set to a directory that contains colors.inc
rem and texture.inc.  For example you could have this in autoexec.bat:
rem
rem    set POLYRAY_PATH=d:\polyray\dat
rem
rem or you could simply uncomment the line above in this batch file (after
rem fixing the directory reference).
rem
rem In a couple of cases, a C compiler is necessary to generate data,
rem in particular for the height field.  The batch files are currently
rem set to use the Symantec C++ compiler, however a simple change
rem of the command line should be all you need for another compiler.
rem
rem In order to generated the animations you will need the program 'dta' on
rem your path.
rem
cd simple
call makesimp
cd ..\lights
call makeligh
cd ..\flare
call makeflar
cd ..\raw
call makeraw
cd ..\superq
call makesupq
cd ..\ripple
call makeripp
cd ..\colormap
call makemaps
cd ..\csg
call makecsg
cd ..\texture
call maketext
cd ..\misc
call makemisc
cd ..\height
call makeheig
cd ..\sweep
call makeswep
cd ..\poly
call makepoly
cd ..\gridded
call makegrid
cd ..\blobs
call makeblob
cd ..\uvmaps
call makeuv
cd ..\person
polyray people.pi -o people.tga -M 512
cd ..\function
call makefunc
cd ..\stones
call makeston
cd ..\animate
call makeanim
cd ..
