REM program to calculate the points for a do-decahedron
REM ***************************************************
DIM V(20, 3): REM verticies matrix (x,y,z)
PI = 3.1415927#
S = 1: REM Length of Side
LRH = S * -1.1135168#: REM lower ring height
M1RH = S * -.2628657: REM middle 1 ring height
M2RH = -M1RH: REM middle 2 ring height
URH = -LRH: REM upper ring height
SRR = S * .8506508: REM small ring radius (i.e. top and bottom)
LRR = S * 1.3763813#: REM large ring radius (i.e. mid 1 and mid 2)
X = 0: Y = 0: Z = 0: REM Centre position
V = 1: REM set array pointer
FOR A = 72 TO 360 STEP 72: REM (around first pentagon)
V(V, 1) = X + (SRR * COS(A * PI / 180))
V(V, 2) = Y + (SRR * SIN(A * PI / 180))
V(V, 3) = Z + LRH
V = V + 1
NEXT A
FOR A = 72 TO 360 STEP 72: REM (around mid 1 ring)
V(V, 1) = X + (LRR * COS(A * PI / 180))
V(V, 2) = Y + (LRR * SIN(A * PI / 180))
V(V, 3) = Z + M1RH
V = V + 1
NEXT A
FOR A = 108 TO 396 STEP 72: REM (around mid 2 ring)
V(V, 1) = X + (LRR * COS(A * PI / 180))
V(V, 2) = Y + (LRR * SIN(A * PI / 180))
V(V, 3) = Z + M2RH
V = V + 1
NEXT A
FOR A = 108 TO 396 STEP 72: REM (around "top" pentagon)
V(V, 1) = X + (SRR * COS(A * PI / 180))
V(V, 2) = Y + (SRR * SIN(A * PI / 180))
V(V, 3) = Z + URH
V = V + 1
NEXT A
REM kill tiny values
FOR V = 1 TO 20
FOR V1 = 1 TO 3
IF ABS(V(V, V1)) < .00001 THEN V(V, V1) = 0
NEXT V1, V

FOR F = 1 TO 12: REM count faces
PRINT "polygon {"
PRINT "points 5"
FOR P = 1 TO 5
READ N
PRINT "vertex"; V(N, 1); " "; V(N, 2); " "; V(N, 3)
NEXT P
PRINT "}"
PRINT
NEXT F
DATA 1,2,3,4,5
DATA 1,2,7,11,6
DATA 2,3,8,12,7
DATA 3,4,9,13,8
DATA 4,5,10,14,9
DATA 5,1,6,15,10
DATA 6,11,16,20,15
DATA 7,12,17,16,11
DATA 8,13,18,17,12
DATA 9,14,19,18,13
DATA 10,15,20,19,14
DATA 16,17,18,19,20

SYSTEM












