REM program to calculate the points for a do-decahedron
REM ***************************************************
DIM V(20, 3): REM verticies matrix (x,y,z)
DIM C(12, 3): REM centre of faces matrix (x,y,z)
PI = 3.1415927#
S = 1: REM Length of Side
SF = .8: REM Stellation factor ... giving the length of the points
LRH = S * -1.1135168#: REM lower ring height
M1RH = S * -.2628657: REM middle 1 ring height
M2RH = -M1RH: REM middle 2 ring height
URH = -LRH: REM upper ring height
SRR = S * .8506508: REM small ring radius (i.e. top and bottom)
LRR = S * 1.3763813#: REM large ring radius (i.e. mid 1 and mid 2)
CRR = S * .9959588: REM centres ring radius
LCRH = S * -.4979798: REM lower centres ring height
UCRH = -LCRH: REM upper centres ring height
X = 0: Y = 0: Z = 0: REM Centre position
C(1, 1) = X
C(1, 2) = Y
C(1, 3) = Z + SF * LRH: REM Find vertical downwards stellation point
C(12, 1) = X
C(12, 2) = Y
C(12, 3) = Z + SF * URH: REM Find vertical upwards stellation point

V = 1: REM set array pointer
FOR A = 72 TO 360 STEP 72: REM (around first pentagon)
V(V, 1) = X + (SRR * COS(A * PI / 180))
V(V, 2) = Y + (SRR * SIN(A * PI / 180))
V(V, 3) = Z + LRH
V = V + 1
NEXT A
C = 7
FOR A = 72 TO 360 STEP 72: REM (around mid 1 ring)
V(V, 1) = X + (LRR * COS(A * PI / 180))
V(V, 2) = Y + (LRR * SIN(A * PI / 180))
V(V, 3) = Z + M1RH
C(C, 1) = X + (SF * CRR * COS(A * PI / 180)): REM around upper centre ring
C(C, 2) = Y + (SF * CRR * SIN(A * PI / 180))
C(C, 3) = Z + UCRH * SF
C = C + 1
V = V + 1
NEXT A
C = 2
FOR A = 108 TO 396 STEP 72: REM (around mid 2 ring)
V(V, 1) = X + (LRR * COS(A * PI / 180))
V(V, 2) = Y + (LRR * SIN(A * PI / 180))
V(V, 3) = Z + M2RH
C(C, 1) = X + (SF * CRR * COS(A * PI / 180))
C(C, 2) = Y + (SF * CRR * SIN(A * PI / 180))
C(C, 3) = Z + LCRH * SF
C = C + 1
V = V + 1
NEXT A
FOR A = 108 TO 396 STEP 72: REM (around "top" pentagon)
V(V, 1) = X + (SRR * COS(A * PI / 180))
V(V, 2) = Y + (SRR * SIN(A * PI / 180))
V(V, 3) = Z + URH
V = V + 1
NEXT A
REM kill tiny values
FOR V = 1 TO 20
FOR V1 = 1 TO 3
IF ABS(V(V, V1)) < .00001 THEN V(V, V1) = 0
IF V <= 12 THEN IF ABS(C(V, V1)) < .00001 THEN C(V, V1) = 0
NEXT V1, V

FOR F = 1 TO 12: REM count faces of dodecahedron
FOR S = 1 TO 5: REM count sides of pyramids
PRINT "polygon {"
PRINT "points 3"
READ N, O, P
PRINT "vertex"; V(N, 1); " "; V(N, 2); " "; V(N, 3)
PRINT "vertex"; V(O, 1); " "; V(O, 2); " "; V(O, 3)
PRINT "vertex"; C(P, 1); " "; C(P, 2); " "; C(P, 3)
PRINT "}"
PRINT
NEXT S, F

DATA 1,2,1
DATA 2,3,1
DATA 3,4,1
DATA 4,5,1
DATA 5,1,1

DATA 1,2,2
DATA 2,7,2
DATA 7,11,2
DATA 11,6,2
DATA 6,1,2

DATA 2,3,3
DATA 3,8,3
DATA 8,12,3
DATA 12,7,3
DATA 7,2,3

DATA 3,4,4
DATA 4,9,4
DATA 9,13,4
DATA 13,8,4
DATA 8,3,4

DATA 4,5,5
DATA 5,10,5
DATA 10,14,5
DATA 14,9,5
DATA 9,4,5

DATA 5,1,6
DATA 1,6,6
DATA 6,15,6
DATA 15,10,6
DATA 5,10,6

DATA 6,11,7
DATA 11,16,7
DATA 16,20,7
DATA 20,15,7
DATA 15,6,7

DATA 7,12,8
DATA 12,17,8
DATA 17,16,8
DATA 16,11,8
DATA 11,7,8

DATA 8,13,9
DATA 13,18,9
DATA 18,17,9
DATA 17,12,9
DATA 12,8,9

DATA 9,14,10
DATA 14,19,10
DATA 19,18,10
DATA 18,13,10
DATA 13,9,10

DATA 10,15,11
DATA 15,20,11
DATA 20,19,11
DATA 19,14,11
DATA 14,10,11

DATA 16,17,12
DATA 17,18,12
DATA 18,19,12
DATA 19,20,12
DATA 20,16,12

SYSTEM












