REM program to generate smooth patched mathmatical surface for Vivid
REM
RL = -720
RH = 720
SC = 60: REM number of steps in X and Y directions
SR = (RH - RL) / SC
ZSF = 200: REM set Z scale factor
PI = 3.1415936#
DEG = PI / 180
DIM D(SC, SC, 3): REM set up data array = X,Y,(Zdata, Xnormal, Ynormal, Znormal)
xc = 0: REM reset X count
FOR XD = RL TO RH STEP SR: REM count X degrees
yc = 0: REM reset Y count
FOR YD = RL TO RH STEP SR: REM count Y degrees
        J = (XD ^ 2 + YD ^ 2) ^ .5
        IF J = 0 THEN : J = .000001: GOTO skipzero:
        Z = ZSF * SIN(DEG * J) / J
skipzero:
D(xc, yc, 0) = Z: REM save result
REM figure out surface normals
JLX = ((XD - (SR / 20)) ^ 2 + YD ^ 2) ^ .5
JUX = ((XD + (SR / 20)) ^ 2 + YD ^ 2) ^ .5
ZLX = ZSF * SIN(DEG * JLX) / JLX
ZUX = ZSF * SIN(DEG * JUX) / JUX
ZD = ZUX - ZLX: REM found change in z over 1/10th change in x
D(xc, yc, 1) = -(ZD * 10)

JLY = ((YD - (SR / 20)) ^ 2 + XD ^ 2) ^ .5
JUY = ((YD + (SR / 20)) ^ 2 + XD ^ 2) ^ .5
ZLY = ZSF * SIN(DEG * JLY) / JLY
ZUY = ZSF * SIN(DEG * JUY) / JUY
ZD = ZUY - ZLY: REM found change in z over 1/10th change in y
D(xc, yc, 2) = -(ZD * 10)

yc = yc + 1
NEXT YD
xc = xc + 1
NEXT XD
REM results are now in the array

REM normalise normals
FOR X = 0 TO SC
FOR y = 0 TO SC
D(X, y, 3) = 1: REM set Z normal to 1
N = (D(X, y, 1) ^ 2 + D(X, y, 2) ^ 2 + 1) ^ .5
FOR M = 1 TO 3
D(X, y, M) = D(X, y, M) / N
NEXT M, y, X


FOR X = 0 TO SC - 1
FOR y = 0 TO SC - 1

PRINT "patch {"
PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X; y; D(X, y, 0);
PRINT USING "normal  ##.#####  ##.##### ##.##### "; D(X, y, 1); D(X, y, 2); D(X, y, 3)

PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X; y + 1; D(X, y + 1, 0);
PRINT USING "normal  ##.#####  ##.#####  ##.##### "; D(X, y + 1, 1); D(X, y + 1, 2); D(X, y + 1, 3)

PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X + 1; y; D(X + 1, y, 0);
PRINT USING "normal  ##.#####  ##.##### ##.##### "; D(X + 1, y, 1); D(X + 1, y, 2); D(X + 1, y, 3)
PRINT "}"
PRINT

PRINT "patch {"
PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X + 1; y; D(X + 1, y, 0);
PRINT USING "normal  ##.#####  ##.#####  ##.##### "; D(X + 1, y, 1); D(X + 1, y, 2); D(X + 1, y, 3)

PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X + 1; y + 1; D(X + 1, y + 1, 0);
PRINT USING "normal  ##.#####  ##.#####  ##.##### "; D(X + 1, y + 1, 1); D(X + 1, y + 1, 2); D(X + 1, y + 1, 3)

PRINT USING "vertex ##.#####  ##.#####  ##.##### "; X; y + 1; D(X, y + 1, 0);
PRINT USING "normal  ##.#####  ##.#####  ##.##### "; D(X, y + 1, 1); D(X, y + 1, 2); D(X, y + 1, 3)
PRINT "}"
PRINT

NEXT y, X
SYSTEM




